class ZoomSel
	def initialize
		@l = nil
	end
	def activate
		@model = Sketchup.active_model
		@v = @model.active_view
		@model.start_operation "zoomsel2"
		@camera = Sketchup::Camera.new(@v.camera.eye, @v.camera.target, @v.camera.up, @v.camera.perspective?, @v.camera.fov)
		Sketchup::set_status_text($exStrings.GetString("Right-click to quit..."), SB_PROMPT)
		zoomsel2
	end
	def deactivate(view)
		@model.active_view.camera = @camera
		@l.each{|e|e.hidden=false}
		@model.commit_operation
	end
	def onRButtonDown(flags, x, y, view)
		@model.active_view.camera = @camera
		@model.select_tool nil 
	end
	def zoomsel2
		sel = @model.selection
		if sel.empty?
			@v.zoom_extents
			@v.invalidate
		else	
			@l = seliso
			if Sketchup.active_model.rendering_options["InactiveHidden"] == true
				Sketchup.active_model.rendering_options["InactiveHidden"] = !Sketchup.active_model.rendering_options["InactiveHidden"]
				@v.zoom(sel)
				@v.invalidate
				Sketchup.active_model.rendering_options["InactiveHidden"] = !Sketchup.active_model.rendering_options["InactiveHidden"]
			else
				@v.zoom(sel)
				@v.invalidate
			end
		end	
	end
	def seliso
		l = []
		sel = @model.selection
		ents = @model.active_entities
		ents.each do |e| 
			e.hidden = true if not sel.to_a.include?(e)
			l.push(e) if e.hidden?
		end
		return l
	end
end

if not file_loaded?("zoomsel2.rb")
	UI.add_context_menu_handler do |menu|
		menu.add_item("Zoom sel 2") { Sketchup.active_model.select_tool ZoomSel.new }
	end
end
file_loaded("zoomsel2.rb")